{**************************************}
{ Copyright (C) MarinovSoft 2000-2006  }
{ http://marinovsoft.narod.ru          }
{ super386@rambler.ru                  }
{**************************************}

Uses Windows;
Type
  TWinVersion = (WVUnknown,WV95,WV98,WVME,WVNT3,WVNT4,WVW2K,WVXP);

Function DetectWinVersion : TWinVersion;
Var
  OsVersionInfo : TOsVersionInfo;
Begin
  Result := WVUnknown;
  OsVersionInfo.DwOsVersionInfoSize := SizeOf(TOsVersionInfo);
  If Getversionex(OsVersionInfo) Then Begin
    Case OsVersionInfo.DwMajorVersion Of
      3:  Result := WVNT3;
      4:  Case OsVersionInfo.DwMinorVersion Of
        0: If OsVersionInfo.DwPlatformId = Ver_Platform_Win32_Nt
        Then Result := WVNT4
        Else Result := WV95;
        10: Result := WV98;
        90: Result := WVME;
      End;
      5:  Case OsVersionInfo.DwMinorVersion Of
        0: Result := WVW2K;
        1: Result := WVXP;
      End;
    End;
    WriteLn(OsVersionInfo.Szcsdversion);
    WriteLn(LoWord(OsVersionInfo.Dwbuildnumber));
  End;
End;

Function DetectWinVersionStr : String;
Const
  Versstr : Array[TWinVersion] Of String = (
    'Unknown',
    'Windows 95',
    'Windows 98',
    'Windows ME',
    'Windows NT 3',
    'Windows NT 4',
    'Windows 2000',
    'Windows XP');
Begin
  Result := Versstr[DetectWinVersion];
End;
Begin
  WriteLn(DetectWinVersionStr);
End.
